using System;
using System.Collections.Generic;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.Windows.Forms;

namespace MetallicCircle {
	public class Form1 : Form {
		private System.Windows.Forms.Panel panel1;
		private Brush brush1;

		public Form1() {
			// panel1
			panel1=new System.Windows.Forms.Panel();
			panel1.BackColor=System.Drawing.Color.White;
			panel1.Dock=System.Windows.Forms.DockStyle.Fill;
			panel1.Name="panel1";
			panel1.Paint+=new System.Windows.Forms.PaintEventHandler(panel1_Paint);
			panel1.Resize+=new System.EventHandler(panel1_Resize);
			// Form1
			ClientSize=new System.Drawing.Size(300, 300);
			Controls.Add(panel1);
			Name="Form1";
			Text="Metallic Circle";
		}

		private static Brush createCircularMetalBrush() {
			List<PointF> points=new List<PointF>();
			List<Color> colors=new List<Color>();
			int darkest=80;
			int lightest=255;

			double rplus=1.03;
			for (int i=0; i<360; i+=5) {
				double angle=i*Math.PI/180;
				double cos=Math.Cos(angle);
				double sin=Math.Sin(angle);
				points.Add(new PointF((float)(rplus*cos), (float)(rplus*sin)));
				angle=(i-45)*Math.PI/180;
				cos=Math.Cos(angle);
				int c=darkest+(int)((lightest-darkest)*cos*cos);
				colors.Add(Color.FromArgb(c, c, c));
			}
			PathGradientBrush brush = new PathGradientBrush(points.ToArray());
			brush.SurroundColors = colors.ToArray();
			brush.CenterColor = Color.White;
			return brush;
		}

		private void panel1_Paint(object sender, PaintEventArgs e) {
			if (brush1==null) brush1=createCircularMetalBrush();
			Graphics g=e.Graphics;
			int cx=panel1.Width/2;
			int cy=panel1.Height/2;
			int r=cx;
			if (r>cy) r=cy;
			r-=20;	// margin

			g.TranslateTransform(cx, cy);
			g.ScaleTransform(r, r);
			g.FillEllipse(brush1, new RectangleF(-1, -1, 2, 2));
		}

		private void panel1_Resize(object sender, EventArgs e) {
			panel1.Invalidate();
		}
	}
}
